// Program to turn font header files into font resource files
// Operates on Version 3.0 .FNT files ONLY! Use BLNK6x10.FNT
// as in input file.
#include <stdio.h>
#include <stdlib.h>

void main(int argc, char *argv[])
	{
	FILE *in, *out, *tmp;
	int chars,width,height,i,j,c;
   unsigned char charimage[500];

	if (argc<6)
		{
		printf("Need 5 args: infile outfile numchars width height");
		return;
		}

	chars = atoi(argv[3]);
	height = atoi(argv[5]);
	width = (atoi(argv[4])+7) >> 3;

	if (width*height > 500)
		{
		printf("Character size too large.");
		return;
      }

	printf("Converting %d chars, each %d bytes long...\n",chars, width * height);

	if (!(in = fopen(argv[1],"rt")) ||
			!(out = fopen(argv[2],"rb")) ||
			!(tmp = fopen("$$$temp.fnt", "wb")) )
   	{
		perror("Could not open input/output file");
		return;
		}

   //Copy header
	for (i=0; i<922; i++)
		fputc(fgetc(out), tmp);


	for (; chars; chars--)
		{
		printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%d characters left",chars-1);

      //Read in character, storing bottom up into array
		for (i=0; i<height; i++)
			for (j=0; j<width; j++)
				{
				fgetc(out);
				fscanf(in, "%x,", &c);
				charimage[(height-(i+1))*width + j] = (unsigned char)(c>>8);
				}

      //Write out in correct order
		for (i=0; i<height; i++)
			for (j=0; j<width; j++)
				fputc(charimage[i*width + j], tmp);

		//Write out blanks between chars
		for (i=0; i<width*height; i++)
			{
			fgetc(out);
			fputc(0,tmp);
			}
		}

	//Copy rest of file
	while (!feof(out))
		fputc(fgetc(out), tmp);

	fclose(in);
	fclose(out);
	fclose(tmp);

	//Move temp to out file name
	unlink(argv[2]);
	rename("$$$temp.fnt", argv[2]);

	printf("\nAll done!\n");
	}
	 